/*
** Copyright (C) 1999 Eleftherios Gkioulekas <lf@amath.washington.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

/* 
 * Undefine aliases for all the declarations so that the declarations
 * can be redefined for a different type 
 */

/* The data types */
#undef mu_array
#undef mu_matrix
#undef mu_cube

/* Methods for 1d arrays */
#undef mu_array_initialize
#undef mu_array_alloc
#undef mu_array_alloc_from_buffer
#undef mu_array_alias
#undef mu_array_free
#undef mu_array_realloc
#undef mu_array_realloc_from_buffer
#undef mu_array_realias
#undef mu_array_contiguous_p
#undef mu_array_to_contiguous
#undef mu_array_address
#undef mu_array_get
#undef mu_array_set

/* Methods for 2d arrays */
#undef mu_matrix_initialize
#undef mu_matrix_alloc
#undef mu_matrix_alloc_from_buffer
#undef mu_matrix_alias
#undef mu_matrix_free
#undef mu_matrix_realloc
#undef mu_matrix_realloc_from_buffer
#undef mu_matrix_realias
#undef mu_matrix_contiguous_p
#undef mu_matrix_to_contiguous
#undef mu_matrix_address
#undef mu_matrix_get
#undef mu_matrix_set
#undef mu_matrix_transpose_contiguous_p
#undef mu_matrix_transpose

/* Methods for 3d arrays */
#undef mu_cube_initialize
#undef mu_cube_alloc
#undef mu_cube_alloc_from_buffer
#undef mu_cube_alias
#undef mu_cube_free
#undef mu_cube_realloc
#undef mu_cube_realloc_from_buffer
#undef mu_cube_realias
#undef mu_cube_contiguous_p
#undef mu_cube_address
#undef mu_cube_get
#undef mu_cube_set

/* Helper de-allocators */
#undef mu_array_free_many
#undef mu_matrix_free_many
#undef mu_cube_free_many

/* Derived arrays, matrices, cubes */

/* Nulls */
#undef mu_array_null
#undef mu_matrix_null
#undef mu_cube_null

/* Subsidiary */
#undef mu_array_sub
#undef mu_matrix_sub
#undef mu_cube_sub

/* Interlaced */
#undef mu_array_interlaced
#undef mu_matrix_interlaced
#undef mu_cube_interlaced

/* Slicing */
#undef mu_matrix_to_array
#undef mu_cube_to_array
#undef mu_cube_to_matrix

/* Smart array I/O */

/* Writing */
#undef mu_array_write 
#undef mu_matrix_write 
#undef mu_cube_write 

/* Reading */
#undef mu_array_read 
#undef mu_matrix_read 
#undef mu_cube_read 

